package jp.flup.whiteboard;

import java.util.Iterator;
import java.util.Set;

import org.red5.server.adapter.ApplicationAdapter;
import org.red5.server.api.IClient;
import org.red5.server.api.IConnection;
import org.red5.server.api.IScope;
import org.red5.server.api.Red5;
import org.red5.server.api.service.IServiceCapableConnection;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Application extends ApplicationAdapter
{
	protected static Logger log = LoggerFactory.getLogger(Application.class);
	
	public Application()
	{
		super();
		log.debug("construct Application");
	}

	public String drawLine(IConnection conn, int startX, int startY, int endX, int endY)
	{
		IScope scope = Red5.getConnectionLocal().getScope();
		Set<IClient> clients = scope.getClients();
		Iterator<IClient> it = clients.iterator();
		log.debug("drawLine start");
		if(clients.isEmpty())
			log.debug("client list is empty");
		Object[] params = new Object[]{startX, startY, endX, endY};
		while(it.hasNext())
		{
			IClient client = it.next();
			Set<IConnection> connset = client.getConnections();
			Iterator<IConnection> it_con = connset.iterator();
			
			while(it_con.hasNext())
			{
				IConnection connection = it_con.next();
				if(connection instanceof IServiceCapableConnection)
				{
					IServiceCapableConnection sc = (IServiceCapableConnection)connection;
					log.info("drawLine");
					sc.invoke("drawLine", params);
				}
				else
					log.debug("This connection is not IServiceCapableConnection");
			}
		}
		log.debug("drawLine end");
		return "OK";
	}
}
